﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using WpfApplication5.ViewModels;

namespace WpfApplication5
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            BindGraphSource();
        }

        private void BindGraphSource()
        {
            int uniqueIdCounter = 0;
            CustomGraphSource source = new CustomGraphSource();
            NodeModel rootItem = new NodeModel() { Content = "CEO", Position = new Point(200, 20), Id = (uniqueIdCounter++).ToString() };
            source.AddNode(rootItem);

            NodeModel unitOne = new NodeModel() { Content = "Unit Manager USA", Position = new Point(100, 100), Id = (uniqueIdCounter++).ToString() };
            source.AddNode(unitOne);
            source.AddLink(new LinkModel(rootItem, unitOne)
            {
                Color = new SolidColorBrush(Colors.Green),
                ConnectionType = Telerik.Windows.Diagrams.Core.ConnectionType.Polyline,
                SourceCapType = Telerik.Windows.Diagrams.Core.CapType.Arrow1Filled,
                TargetCapType = Telerik.Windows.Diagrams.Core.CapType.Arrow2Filled,
                Visibility = System.Windows.Visibility.Visible
            });

            NodeModel unitTwo = new NodeModel() { Content = "Unit Manager Europe", Position = new Point(300, 100), Id = (uniqueIdCounter++).ToString() };
            source.AddNode(unitTwo);
            source.AddLink(new LinkModel(rootItem, unitTwo)
            {
                Color = new SolidColorBrush(Colors.Blue),
                ConnectionType = Telerik.Windows.Diagrams.Core.ConnectionType.Polyline,
                SourceCapType = Telerik.Windows.Diagrams.Core.CapType.Arrow1,
                TargetCapType = Telerik.Windows.Diagrams.Core.CapType.Arrow2,
                Visibility = System.Windows.Visibility.Visible
            });

            this.diagram.GraphSource = source;
        }
    }
}
