﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace WpfApplication5.ViewModels
{
    public class CustomGraphSource : SerializableGraphSourceBase<NodeModel, LinkModel>
    {
        public override string GetNodeUniqueId(NodeModel node)
        {
            return node.Id;
        }

        public override LinkModel DeserializeLink(Telerik.Windows.Diagrams.Core.IConnection connection, Telerik.Windows.Diagrams.Core.SerializationInfo info)
        {
            LinkModel link =  base.DeserializeLink(connection, info);
            link.SourceCapType = (CapType)Enum.Parse(typeof(CapType), info["SourceCapType"].ToString());
            link.TargetCapType = (CapType)Enum.Parse(typeof(CapType), info["TargetCapType"].ToString());
            link.Color = new SolidColorBrush(new Color() { A = Byte.Parse(info["ColorA"].ToString()),
                                                           B = Byte.Parse(info["ColorB"].ToString()),
                                                           G =Byte.Parse(info["ColorG"].ToString()),
                                                           R = Byte.Parse(info["ColorR"].ToString())
            });
            link.Visibility = (Visibility)Enum.Parse(typeof(Visibility), info["Visibility"].ToString());
            return link;
        }

        public override void SerializeLink(LinkModel link, Telerik.Windows.Diagrams.Core.SerializationInfo info)
        {
            base.SerializeLink(link, info);
            info["SourceCapType"] = link.SourceCapType;
            info["TargetCapType"] = link.TargetCapType;
            info["ColorA"] = link.Color.Color.A.ToString();
            info["ColorB"] = link.Color.Color.B.ToString();
            info["ColorG"] = link.Color.Color.G.ToString();
            info["ColorR"] = link.Color.Color.R.ToString();
            info["Visibility"] = link.Visibility.ToString();
        } 
    }
}
