﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace WpfApplication5.ViewModels
{
    public class LinkModel : LinkViewModelBase<NodeModel>
    {
        public LinkModel(NodeModel source, NodeModel target)
            : base(source, target)
        {

        }

        public LinkModel()
        {

        }
        private Visibility visibility;
        /// <summary>
        ///     Gets or sets the visibility.
        /// </summary>
        public Visibility Visibility
        {
            get
            {
                return this.visibility;
            }
            internal set
            {
                if (this.visibility != value)
                {
                    this.visibility = value;
                    OnPropertyChanged("Visibility");
                }
            }
        }

        public SolidColorBrush Color { get; set; }

        private CapType sourceCapType;
        /// <summary>
        ///     Gets or sets the source CapType of the link.
        /// </summary>
        public CapType SourceCapType
        {
            get
            {
                return this.sourceCapType;
            }
            internal set
            {
                if (this.sourceCapType != value)
                {
                    this.sourceCapType = value;
                    OnPropertyChanged("SourceCapType");
                }
            }
        }


        private CapType targetCapType;
        /// <summary>
        ///     Gets or sets the target CapType of the link.
        /// </summary>
        public CapType TargetCapType
        {
            get
            {
                return this.targetCapType;
            }
            internal set
            {
                if (this.targetCapType != value)
                {
                    this.targetCapType = value;
                    OnPropertyChanged("TargetCapType");
                }
            }
        }


        private ConnectionType connectionType;
        /// <summary>
        ///     Gets or sets the type of the link.
        /// </summary>
        public ConnectionType ConnectionType
        {
            get
            {
                return this.connectionType;
            }
            internal set
            {
                if (this.connectionType != value)
                {
                    this.connectionType = value;
                    OnPropertyChanged("ConnectionType");
                }
            }
        }


    }
}
